
/*** Generated through Lumonix shaderFX  by: in 3dsmax at: 26/05/2012 18:55:04  ***/ 

// This FX shader was built to support 3ds Max's standard shader compiler. 


bool SwitchUVCoords
<
	string UIName = "Lightmap UV0 or UV1";
> = true;
 
int texcoord0 : Texcoord 
<
	int Texcoord = 0;
	int MapChannel = 1;
	string UIType = "None"; 
>;

int texcoord1 : Texcoord 
<
	int Texcoord = 1;
	int MapChannel = 2;
	string UIType = "None"; 
>;

texture NormalMapTexture : NormalMap
<
	string Name = "";
	string UIName = "Normal Map";
	string ResourceType = "2D";
>;
 
sampler2D NormalMapSampler = sampler_state
{
	Texture = <NormalMapTexture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture DLM1Texture
<
	string Name = "";
	string UIName = "DLM 1";
	string ResourceType = "2D";
>;
 
sampler2D DLM1Sampler = sampler_state
{
	Texture = <DLM1Texture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture DLM2Texture
<
	string Name = "";
	string UIName = "DLM 2";
	string ResourceType = "2D";
>;
 
sampler2D DLM2Sampler = sampler_state
{
	Texture = <DLM2Texture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture DLM3Texture
<
	string Name = "";
	string UIName = "DLM 3";
	string ResourceType = "2D";
>;
 
sampler2D DLM3Sampler = sampler_state
{
	Texture = <DLM3Texture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};

//---------------------------------- 

float4x4 wvp : WorldViewProjection < string UIType = "None"; >;  
float4 eyePosition : WORLDCAMERAPOSITION < string UIType = "None"; >;

// input from application 
struct a2v { 
	float4 position		: POSITION; 
	float4 tangent		: TANGENT; 
	float4 binormal		: BINORMAL; 
	float4 normal		: NORMAL; 

	float2 texCoord		: TEXCOORD0; 
	float2 texCoord1	: TEXCOORD1; 
}; 

// output to fragment program 
struct v2f { 
	float4 position    		: POSITION; 
	float2 texCoord			: TEXCOORD0; 
	float2 texCoord1		: TEXCOORD1;
	float3 eyeVector		: TEXCOORD2;
}; 

v2f av(a2v IN) 
{ 
    v2f OUT = (v2f)0; 
	OUT.position = mul(IN.position, wvp);				//transform vert position to homogeneous clip space 

	IN.texCoord += float2(0.0,1.0);		//this fixes Max's V texcoord which is off by one 
	OUT.texCoord = IN.texCoord;						//pass through texture coordinates from channel 1 
	IN.texCoord1 += float2(0.0,1.0);		//this fixes Max's V texcoord which is off by one 
	OUT.texCoord1 = IN.texCoord1;						//pass through texture coordinates from channel 2 

	float3x3 TBN = float3x3(IN.tangent.rgb, IN.binormal.rgb, IN.normal.rgb);
	OUT.eyeVector = mul(normalize(eyePosition - IN.position.xyz), TBN);
	
	return OUT; 
} 

float4 DirectionalLightmaps(v2f In) : COLOR 
{ 
	float3 bumpBasis0 = float3( sqrt(2.0f / 3.0f), 		0.0, 					1.0f / sqrt(3.0f)); 
	float3 bumpBasis1 = float3(-(1.0f / sqrt(6.0f)), 	1.0f / sqrt(2.0f), 		1.0f / sqrt(3.0f));
	float3 bumpBasis2 = float3(-(1.0f / sqrt(6.0f)), 	-(1.0f / sqrt(2.0f)), 	1.0f / sqrt(3.0f)); 
	
	float2 UV1 = In.texCoord.xy; 
	float2 UV2 = In.texCoord1.xy; 
	
	float2 textureUVs;
	if (SwitchUVCoords == true)
	{
		textureUVs = UV1;
	}
	else
	{
		textureUVs = UV2;
	}
	
	float4 normalMap = tex2D(NormalMapSampler, textureUVs);
	normalMap.xyz = normalMap.xyz * 2 - 1; 
	normalMap.xyz = normalize(normalMap.xyz);
	
	float2 lightmapUVs;
	if (SwitchUVCoords == true)
	{
		lightmapUVs = UV2;
	}
	else
	{
		lightmapUVs = UV1;
	}
	
	float4 DLM1 = tex2D(DLM1Sampler, lightmapUVs);
	float4 DLM2 = tex2D(DLM2Sampler, lightmapUVs);
	float4 DLM3 = tex2D(DLM3Sampler, lightmapUVs);
	
	float3 LightmapContribution = 0;
	LightmapContribution.x = dot(normalMap, bumpBasis0);
	LightmapContribution.y = dot(normalMap, bumpBasis1);
	LightmapContribution.z = dot(normalMap, bumpBasis2);
	LightmapContribution *= LightmapContribution;

	float3 diffuseLight = 0;
	float3 specularLight = 0;
	
	float diffuseSum = dot(LightmapContribution, float3(1.0f, 1.0f, 1.0f));		
	diffuseLight += DLM1 * LightmapContribution.x;
	diffuseLight += DLM2 * LightmapContribution.y;
	diffuseLight += DLM3 * LightmapContribution.z;
	diffuseLight /= diffuseSum;
	
	return float4(diffuseLight, 1); 
}

technique Complete  
{  
	pass ambient  
    {		 
		VertexShader = compile vs_2_0 av(); 
		ZEnable = true; 
		ZWriteEnable = true; 
		CullMode = cw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = false; 
		AlphaTestEnable = FALSE; 
		PixelShader = compile ps_2_0 DirectionalLightmaps(); 
	} 
}    